Index: FlagHistory.h
===================================================================
--- FlagHistory.h	(revision 20911)
+++ FlagHistory.h	(working copy)
@@ -26,10 +26,10 @@
  public:
   void clear();
   void get(char message[]);
-  void add(FlagType* type);
-  std::vector<FlagType*> get(void) { return flagHistory;}
+  void add(const FlagType* type);
+  std::vector<const FlagType*> get(void) { return flagHistory;}
  private:
-  std::vector<FlagType*> flagHistory;
+  std::vector<const FlagType*> flagHistory;
 };
 
 #endif /* __FLAGHISTORY_H__ */
Index: FlagInfo.cxx
===================================================================
--- FlagInfo.cxx	(revision 20911)
+++ FlagInfo.cxx	(working copy)
@@ -16,31 +16,53 @@
 #pragma warning( 4:4786)
 #endif
 
-/* interface header */
+#include "common.h"
+
+// interface header
 #include "FlagInfo.h"
 
-/* system headers */
+// system headers
+#include <stdlib.h>
+#include <string.h>
 #include <iostream>
 
-// implementation-specific bzflag headers
+// common headers
 #include "BZDBCache.h"
 
-/* private */
+// bzfs headers
+#include "bzfs.h"
+#include "CmdLineOptions.h"
 
-/* protected */
+typedef std::map<const FlagType*, int> FlagCountMap;
 
-/* public */
 
-// flags list
-FlagInfo	      *FlagInfo::flagList      = NULL;
-std::vector<FlagType*> FlagInfo::allowedFlags;
-int		    FlagInfo::numExtraFlags = 0;
-int		    FlagInfo::numFlags      = 0;
-int		    FlagInfo::numFlagsInAir;
+// local prototypes
+static int  flagCountMapSum(FlagCountMap& fcm);
+static void flagCountMapClampMin(FlagCountMap& fcm, int min);
+static int  flagCountMapValue(const FlagType* ft, const FlagCountMap& fcm);
+static void addToFlagCountMap(const FlagType* ft, int count, FlagCountMap& fcm);
 
+
+static int numFlagsInAir = 0;
+
+
+/******************************************************************************/
+//
+// FlagInfo
+//
+
+
 FlagInfo::FlagInfo()
 {
+  player    = -1;
+  extra     = true;
+  random    = false;
+  srcZone   = NULL;
+  grabsLeft = 0;
+  shotCount = 0;
+
   // prep flag
+
   flag.type		  = Flags::Null;
   flag.status		  = FlagNoExist;
   flag.endurance	  = FlagNormal;
